#!/usr/bin/python3
# -- coding: UTF-8 --
# -- Author: Camera --


import dbus
import dbus.mainloop.glib
import dbus.service
from gi.repository import GLib
import os
import cv2
INTERFACE = "com.kylin.DetectVideo"
DBUSPATH = "/com/kylin/DetectVideo"

class Camera(dbus.service.Object):
    def __init__(self,path):
        dbus.service.Object.__init__(self, dbus.SystemBus(), path)

    @dbus.service.method(INTERFACE, in_signature='',out_signature="a{sv}")
    def Camera_Detect(self):
        path="/dev"
        res_dict=dict()
        dev_files=os.listdir(path)
        res_list=list()
        for tmp in dev_files:
            if "video" in tmp:
                res_list.append(tmp)
                print("Camera list append:", tmp)
        for tmp_file in res_list: 
            num=tmp_file.replace("video","")
            cap = cv2.VideoCapture(int(num))
            bool_open=cap.isOpened()
            print("Camera bool_open:", bool_open)
            ret,frame=cap.read()
            print("Camera ret is",ret)
            camera_path="/sys/class/video4linux/"+tmp_file+"/name"
            if(ret==False and bool_open==False):
                with open(camera_path,"r") as f:
                    camera_name=f.readline()
                    camera_name=camera_name.replace("\n","")
                res_dict[camera_name]="0"
            elif(ret==False and bool_open==True):
                with open(camera_path,"r") as f:
                    camera_name=f.readline()
                    camera_name=camera_name.replace("\n","")
                res_dict[camera_name]="1"
            elif(ret==True and bool_open==True):
                with open(camera_path,"r") as f:
                    camera_name=f.readline()
                    camera_name=camera_name.replace("\n","")
                res_dict[camera_name]="2"

            cap.release()
            cv2.destroyAllWindows()
        return res_dict

dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
system_bus = dbus.SystemBus()
name = dbus.service.BusName(INTERFACE, system_bus)
mainloop = GLib.MainLoop()
blue = Camera(DBUSPATH)
mainloop.run()
